<?php
   include_once('../include/config.php');

	//Use this only for development mode. Set this equal to 0 when moving to production mode.
	define('DEBUG', 1);

	//show all php errors if debug is 1
	if(DEBUG)
	{
		error_reporting(E_ALL);
		ini_set('display_errors', '1');
	}


	/** This is a nice version of print_r you can use while debugging webpages. It'll print the array prettier. */
	function debug_r($arr)
	{
		if(DEBUG)
		{
			echo '<pre>';
			print_r($arr);
			echo '</pre>';
		}
	}

	/** This function prints out the html encoded version of text. If you are printing out a variable and you know it doesn't contain html, use encho() instead of echo(). Helps a lot in avoiding XSS bugs. */
	function encho($text)
	{
		echo htmlspecialchars($text);
	}

	define('DB_USER', $GLOBALS['CONFIG']['db']['username']);
	define('DB_PASS', $GLOBALS['CONFIG']['db']['password']);
	define('DB_HOST', $GLOBALS['CONFIG']['db']['hostname']);
	define('DB_NAME', $GLOBALS['CONFIG']['db']['database']);
	
	/** This function connects us to the database defined in the macros above. */
	function db_connect()
	{
		$success = mysql_connect(DB_HOST, DB_USER, DB_PASS);		
		if(!$success)
			if(DEBUG)
				exit('MySQL connection failed on line '. __LINE__. ' in file '. __FILE__. "\n");
			else
				echo 'The database connection failed';

		mysql_select_db(DB_NAME);
	}

	/** This function is equivalent to calling mysql_query(sprintf(query, ...)). It will mysql_real_escape all args after the first arg in sprintf.
	 * This is awesome for avoiding SQL injections.
	 * You can set sql_explain=1 in the $_REQUEST to debug sql_queries.
	 */
	function db_query($query)
	{
		$num_args = func_num_args();

		$args = array();
		$args[] = $query;

		for($i = 1; $i < $num_args; $i++)
		{
			$args[] = mysql_real_escape_string(func_get_arg($i));
		}

		$query = call_user_func_array('sprintf', $args);

		if(@$_REQUEST['sql_explain'] == 1)
		{
			debug_r('Query: '.$query."\n");
		}

		$res = mysql_query($query) or die( DEBUG ? 'Mysql Error occurred: '.mysql_error(). '	 File: '.__FILE__. ' Line: '.__LINE__. "\n Query: $query\n": ('A database query failed'));
		return $res;
	}


	/** This function returns back a list of entries in the table. Each entry is an associative array of stuff.
	 * DO NOT USE THIS FOR BIG TABLES
	 */
	function db_fetch_assoc($res)
	{
		$rv = array();
		while($row = mysql_fetch_assoc($res))
		{
			$rv[] = $row;
		}
		return $rv;
	}


	/** Function checks to see if an email is valid. */
	function is_valid_email($email) {
		// First, we check that there's one @ symbol, 
		// and that the lengths are right.
		if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) {
			// Email invalid because wrong number of characters 
			// in one section or wrong number of @ symbols.
			return false;
		}
		// Split it into sections to make life easier
		$email_array = explode("@", $email);
		$local_array = explode(".", $email_array[0]);
		for ($i = 0; $i < sizeof($local_array); $i++) {
			if
				(!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_    }|}~-][A-Za-z0-9!#$%&
				↪'*+/=?^_    }|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$",
				$local_array[$i])) {
					return false;
				}
		}
		// Check if domain is IP. If not, 
		// it should be valid domain name
		if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1])) {
			$domain_array = explode(".", $email_array[1]);
			if (sizeof($domain_array) < 2) {
				return false; // Not enough parts to domain
			}
			for ($i = 0; $i < sizeof($domain_array); $i++) {
				if
					(!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|
					↪([A-Za-z0-9]+))$",
					$domain_array[$i])) {
						return false;
					}
			}
		}
		return true;
	}

	db_connect();
