<?php
include_once('../include/config.php');
include_once('../include/xml2array.php');

//generating the appropriate dirs
mkdir($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/', '0777');
mkdir($GLOBALS['CONFIG']['web_dir'] . '/nextbus/', '0777');

$nextbus_url = 'http://webservices.nextbus.com/service/publicXMLFeed';
$agency = 'rutgers';

$routes = file_get_contents($nextbus_url . '?a=' . $agency . '&command=routeConfig');

$routes = xml2array($routes);
$routes = $routes['body']['route'];

$list = array();
$stops_list = array();

for($i = 0; $i < count($routes); $i++) 
{
   // attr => array(tag, title)
   // stop => # => attr => tag, title
   $list[$i]['route_name'] = $routes[$i]['attr']['title'];   
   $list[$i]['route_id'] = $routes[$i]['attr']['tag'];
  // $list[$i]['stops'] = count($routes[$i]['stops']);   
   for ($j = 0; $j < count($routes[$i]['stop']); $j++)
   {
      if (!isset($routes[$i]['stop'][$j]['attr']['stopId']))
         continue;

      $list[$i]['stops'][$j]['stop_name'] = $routes[$i]['stop'][$j]['attr']['title'];
      $list[$i]['stops'][$j]['stop_id'] = $routes[$i]['stop'][$j]['attr']['stopId'];
      array_push($stops_list, 
         array(
            "stop_name" => $list[$i]['stops'][$j]['stop_name'], 
            "stop_id" => $list[$i]['stops'][$j]['stop_id'], 
            "lat" => $routes[$i]['stop'][$j]['attr']['lat'], 
            "lon" => $routes[$i]['stop'][$j]['attr']['lon']
         )
      );
   }

}

// unique array of stops
$stops_output = array();
$ignore_list = array('1036');
foreach ($stops_list as $check_stop)
{
   $exists = false;
   foreach ($stops_output as $with_stop)
   {
      if ($with_stop['stop_id'] == $check_stop['stop_id'])
      {
         $exists = true;
         break;
      }
   }

   if (in_array($check_stop['stop_id'], $ignore_list))
   {
      $exists = true;
   }   

   if (!$exists)
      $stops_output[] = $check_stop;
}

//sorting
foreach ($stops_output as $key => $row) {
    $stop_names[$key]  = $row['stop_name'];
    $stop_ids[$key] = $row['stop_id'];
}

array_multisort($stop_names, SORT_ASC, $stop_ids, SORT_ASC, $stops_output);

// list of stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stops_list.txt', 'w');
fwrite($file, json_encode($stops_output));
fclose($file);

// lines -> stops
$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/route_config.txt', 'w');
fwrite($file, json_encode($list));
fclose($file);

foreach ($list as $route)
{   
   exec('php-cgi ./line2stops-times.php route=' . $route['route_id'] . ' > /dev/null 2>&1 &');
}

foreach ($stops_output as $stop)
{
   exec('php-cgi ./stop2lines-times.php stop=' . $stop['stop_id'] . ' > /dev/null 2>&1 &');
}
?>
